<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Const strSQL as String = "SELECT * FROM titles"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgTitles.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Function DisplaySales(ytdSales as Object) as String
      If ytdSales.Equals(DBNull.Value) then
        'ytdSales is NULL
        Return "No copies sold"
      Else
        'ytdSales is some integer value
        Return String.Format("{0:#,###}", Convert.ToInt32(ytdSales))
      End If
    End Function
    
    Function DisplayRoyalty(royalty as Object) as String
      If royalty.Equals(DBNull.Value) then
        'royalty is NULL
        Return "Royalty not<br>yet determined"
      Else
        'royalty is some integer value
        Return royalty.ToString() & "%"
      End If
    End Function
    
    Function DisplayAdvance(advance as Object) as String
      If advance.Equals(DBNull.Value) then
        'advance is NULL
        Return "Advance not<br>yet determined"
      Else
        'advance is some integer value
        Return String.Format("{0:c}", Convert.ToDouble(advance))
      End If
    End Function
    
    
    Function DisplayGross(ytdSales as Object, price as Object) as String
      If ytdSales.Equals(DBNull.Value) or price.Equals(DBNull.Value) then
        Return "$0.00"
      Else
        Dim gross as Double
        gross = Convert.ToDouble(price) * Convert.ToInt32(ytdSales)
    
        Return String.Format("{0:c}", gross)
      End If
    End Function
    
    Function DisplayAuthorsRoyaltyTake(ytdSales as Object, price as object, _
                                       royalty as Object) as String
      If ytdSales.Equals(DBNull.Value) or price.Equals(DBNull.Value) _
           or royalty.Equals(DBNull.value) then
        Return "$0.00"
      Else
        Dim gross as Double, authorsRoyalty as Double
        gross = Convert.ToDouble(price) * Convert.ToInt32(ytdSales)
        authorsRoyalty = gross * Convert.ToInt32(royalty) / 100
    
        Return String.Format("{0:c}", authorsRoyalty)
      End If
    End Function

</script>
<asp:DataGrid id="dgTitles" runat="server"
    Font-Name="Verdana" Font-Size="10pt"
    AlternatingItemStyle-BackColor="#eeeeee"
    AutoGenerateColumns="False" CellPadding="3"
    
    HeaderStyle-HorizontalAlign="Center"
    HeaderStyle-Font-Bold="True"
    HeaderStyle-Font-Size="13pt">
  <Columns>
    <asp:BoundColumn DataField="title" HeaderText="Title" />
    <asp:BoundColumn DataField="price" HeaderText="Price"
        ItemStyle-HorizontalAlign="Right" DataFormatString="{0:c}" />
    <asp:TemplateColumn HeaderText="Copies Sold"
         ItemStyle-HorizontalAlign="Right">
      <ItemTemplate>
        <%# DisplaySales(DataBinder.Eval(Container.DataItem, "ytd_sales")) %>
      </ItemTemplate>
    </asp:TemplateColumn>  
    <asp:TemplateColumn HeaderText="Advance"
         ItemStyle-HorizontalAlign="Right">
      <ItemTemplate>
        <%# DisplayAdvance(DataBinder.Eval(Container.DataItem, "advance")) %>
      </ItemTemplate>
    </asp:TemplateColumn>     
    <asp:TemplateColumn HeaderText="Royalty"
         ItemStyle-HorizontalAlign="Right">
      <ItemTemplate>
        <%# DisplayRoyalty(DataBinder.Eval(Container.DataItem, "royalty")) %>
      </ItemTemplate>
    </asp:TemplateColumn>     
    <asp:TemplateColumn HeaderText="Gross"
         ItemStyle-HorizontalAlign="Right">
      <ItemTemplate>
        <%# DisplayGross(DataBinder.Eval(Container.DataItem, "ytd_sales"), _
                         DataBinder.Eval(Container.DataItem, "price")) %>
      </ItemTemplate>
    </asp:TemplateColumn>     
    <asp:TemplateColumn HeaderText="Royalty Payout"
         ItemStyle-HorizontalAlign="Right">
      <ItemTemplate>
        <%# DisplayAuthorsRoyaltyTake(DataBinder.Eval(Container.DataItem, "ytd_sales"), _
                         DataBinder.Eval(Container.DataItem, "price"), _
                         DataBinder.Eval(Container.DataItem, "royalty")) %>
      </ItemTemplate>
    </asp:TemplateColumn>     
  </Columns>
</asp:DataGrid>
