<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Const strSQL as String = "SELECT * FROM titles"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgTitles.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Function DisplaySales(ytdSales as Object) as String
      If ytdSales.Equals(DBNull.Value) then
        'ytdSales is NULL
        Return "No copies sold"
      Else
        'ytdSales is some integer value
        Return String.Format("{0:#,###}", Convert.ToInt32(ytdSales))
      End If
    End Function
    
   
    Sub dgTitles_DataBound(sender as Object, e as DataGridItemEventArgs)
      'Add a client-side onclick event handler to the Details button
      'First, make sure that we're not dealing with a header or footer item
      If e.Item.ItemType <> ListItemType.Header AND _
            e.Item.ItemType <> ListItemType.Footer then
            
        Dim detailsButton as Button = e.Item.Cells(0).Controls(0)
      
        'Determine the gross and author's royalties
        Dim gross as Double = 0.0, authorsRoyalty as Double = 0.0
      
        'Make sure the values aren't null
        If DBNull.Value.Equals(DataBinder.Eval(e.Item.DataItem, "price")) or _
           DBNull.Value.Equals(DataBinder.Eval(e.Item.DataItem, "ytd_sales")) or _
           DBNull.Value.Equals(DataBinder.Eval(e.Item.DataItem, "royalty")) then
             'do nothing
        Else
           gross = Convert.ToDouble(DataBinder.Eval(e.Item.DataItem, "price")) * _
                Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "ytd_sales"))
              
           authorsRoyalty = gross / 100 * _
               Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "royalty"))
        End If 
      
        detailsButton.Attributes("onclick") = "alert('Title: " & _
               DataBinder.Eval(e.Item.DataItem, "title").ToString().Replace("'", "\'") & _
               "\nGross: " & _
               String.Format("{0:c}", gross) & "\n" & _
               "Author\'s Royalties: " & _
               String.Format("{0:c}", authorsRoyalty) & "'); return false;"
      End If
    End Sub

</script>

<form runat="server">
  <asp:DataGrid id="dgTitles" runat="server"
     Font-Name="Verdana" Font-Size="10pt"
     AlternatingItemStyle-BackColor="#eeeeee"
     AutoGenerateColumns="False" CellPadding="3"
    
     OnItemDataBound="dgTitles_DataBound"
    
     HeaderStyle-HorizontalAlign="Center"
     HeaderStyle-Font-Bold="True"
     HeaderStyle-Font-Size="13pt">
   <Columns>
     <asp:ButtonColumn HeaderText="Details" Text="Details"
           ButtonType="PushButton" ItemStyle-HorizontalAlign="Center" />
     <asp:BoundColumn DataField="title" HeaderText="Title" />
     <asp:BoundColumn DataField="price" HeaderText="Price"
         ItemStyle-HorizontalAlign="Right" DataFormatString="{0:c}" />
     <asp:TemplateColumn HeaderText="Copies Sold"
          ItemStyle-HorizontalAlign="Right">
       <ItemTemplate>
         <%# DisplaySales(DataBinder.Eval(Container.DataItem, "ytd_sales")) %>
       </ItemTemplate>
     </asp:TemplateColumn>  
   </Columns>
  </asp:DataGrid>
</form>
