Private IsBeingEdited As Boolean = False


Public Overrides Sub InitializeCell(ByVal cell As TableCell, ByVal columnIndex As Integer, ByVal itemType As ListItemType)
    MyBase.InitializeCell(cell, columnIndex, itemType)

    Select Case itemType
        Case ListItemType.EditItem
            'Add a TextBox
            Dim txtProfane As New TextBox()
            txtProfane.ID = "txtProfane"
            cell.Controls.Add(txtProfane)
            IsBeingEdited = True

            AddHandler cell.DataBinding, AddressOf Me.PerformDataBinding

        Case ListItemType.AlternatingItem, ListItemType.Item, ListItemType.SelectedItem
            IsBeingEdited = False
            AddHandler cell.DataBinding, AddressOf Me.PerformDataBinding
    End Select
End Sub


Private Sub PerformDataBinding(ByVal sender As Object, ByVal e As EventArgs)
    Dim cell As TableCell = sender
    Dim gridItem As DataGridItem = cell.NamingContainer
    Dim dataItem As Object = gridItem.DataItem

    If Me.DataField <> String.Empty Then
        If Not IsBeingEdited Then
            cell.Text = PerformCensorship(DataBinder.Eval(dataItem, Me.DataField))
        Else
            Dim txtProfane As TextBox = cell.FindControl("txtProfane")
            txtProfane.Text = DataBinder.Eval(dataItem, Me.DataField)
        End If
    End If
End Sub
