Imports System
Imports System.Web.UI.WebControls
Imports System.Web.UI
Imports System.Web

Public Class CensorColumn
    Inherits DataGridColumn

    Public Overrides Sub InitializeCell(ByVal cell As TableCell, ByVal columnIndex As Integer, ByVal itemType As ListItemType)
        MyBase.InitializeCell(cell, columnIndex, itemType)

        Select Case itemType
            Case ListItemType.AlternatingItem, ListItemType.Item, ListItemType.SelectedItem
                AddHandler cell.DataBinding, AddressOf Me.PerformDataBinding
        End Select

    End Sub

    Private Sub PerformDataBinding(ByVal sender As Object, ByVal e As EventArgs)
        Dim cell As TableCell = sender
        Dim gridItem As DataGridItem = cell.NamingContainer
        Dim dataItem As Object = gridItem.DataItem


        If Me.DataField <> String.Empty Then
            cell.Text = DataBinder.Eval(dataItem, Me.DataField)
        End If
    End Sub

    Private m_dataField As String

    Public Property DataField() As String
        Get
            Return Me.m_dataField
        End Get
        Set(ByVal Value As String)
            Me.m_dataField = Value
        End Set
    End Property
End Class
