    Private Function PerformCensorship(ByVal censorMe As String) As String
        'If no CensorFile has been specified, return censorMe string
        If Me.CensorFile = String.Empty Then
            Return censorMe
        End If

        'Convert the CensorFile path into a physical path
        Dim filepath As String = HttpContext.Current.Server.MapPath(Me.CensorFile)

        'Make sure the file exists
        If Not File.Exists(filepath) Then
            Throw New Exception("File " & filepath & " does not exist!")
            Return censorMe
        End If

        'Read the XML file's contents
        Dim censorDoc As New XmlDocument()
        censorDoc.PreserveWhitespace = True
        censorDoc.Load(filepath)

        Dim root As XmlNode = censorDoc.FirstChild

        Dim findNodes As XmlNodeList = root.SelectNodes("/censors/censor/find")
        Dim replaceNodes As XmlNodeList = root.SelectNodes("/censors/censor/replace")

        Dim re As Regex
        Dim results As String = censorMe
        Dim i As Integer
        For i = 0 To findNodes.Count - 1
            re = New Regex("\b" & findNodes.Item(i).InnerText & "\b", RegexOptions.IgnoreCase)
            results = re.Replace(results, replaceNodes.Item(i).InnerText)
        Next

        Return results
    End Function
