<%@ Page Language="C#" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
        BindData();
    }
    
    
    IEnumerable ItemsInCart()
    {
       // create the data to bind to the Repeater
       DataTable dt = new DataTable();
       DataRow dr;
    
       dt.Columns.Add(new DataColumn("ProductID", typeof(int)));
       dt.Columns.Add(new DataColumn("Name", typeof(string)));
       dt.Columns.Add(new DataColumn("Price", typeof(float)));
    
       // Add some rows
       for (int i = 0; i < 10; i++)
       {
          dr = dt.NewRow();
    
          dr[0] = i+1;
          dr[1] = "Item " + i.ToString();
          dr[2] = (float) 1.23 * i;
    
          dt.Rows.Add(dr);
       }
    
       DataView dv = new DataView(dt);
       return dv;
    }
    
    
    string GetProductDescription(int ID)
    {
      return "This is the description for product " + ID.ToString() + "...";
    }
    
    
    void BindData()
    {
      dgCart.DataSource = ItemsInCart();
      dgCart.DataBind();
    }
    
    
    void dgCart_ItemCommand(object sender, DataGridCommandEventArgs e)
    {
      // Get the ProductID of the selected row.
      int selectedProductID = Convert.ToInt32(e.Item.Cells[2].Text);
    
      if (e.CommandName == "RemoveButton")
      {
        // Remove the Product from the Cart and rebind the DataGrid
        RemoveItemFromCart(selectedProductID);
        BindData();
      }
      if (e.CommandName == "DetailsButton")
      {
        // Display the Product Details
        lblProductDetails.Text = GetProductDescription(selectedProductID);
      }
    }
    
    
    void RemoveItemFromCart(int ID)
    {
    
    }

</script>
<form runat="server">
  <p>
  <asp:label runat="server" id="lblProductDetails"
         Font-Name="Verdana" Font-Size="11pt" />
  </p>

  <asp:DataGrid runat="server" id="dgCart"
        AutoGenerateColumns="False"
        Font-Name="Verdana"
        Font-Size="8pt"
        OnItemCommand="dgCart_ItemCommand">
  
    <HeaderStyle HorizontalAlign="Center" Font-Bold="True"
         Font-Size="11pt" BackColor="Navy" ForeColor="White" />
  
    <Columns>
      <asp:ButtonColumn Text="Remove" ButtonType="PushButton"
              HeaderText="Remove" CommandName="RemoveButton" />
      <asp:ButtonColumn Text="Details" ButtonType="PushButton"
              HeaderText="Details" CommandName="DetailsButton" />
              
      <asp:BoundColumn DataField="ProductID" Visible="False" />
      <asp:BoundColumn DataField="Name" HeaderText="Product Name" />
      <asp:BoundColumn DataField="Price" HeaderText="Price"
              ItemStyle-HorizontalAlign="right"
              DataFormatString="{0:c}" />
    </Columns>
  </asp:DataGrid>
</form>
