<%@ Page Language="vb" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Const strSQL as String = "SELECT * FROM titles"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgTitles.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Function GetBookDetails(TitleID as String) as SqlDataReader
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String
      strSQL = "SELECT title, type, pubdate, notes FROM titles " & _
               "WHERE title_id = @TitleID"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      '3. Create a parameter for the TitleID param
      Dim paramTitleID as SqlParameter
      paramTitleID = New SqlParameter("@TitleID", SqlDbType.VarChar, 10)
      paramTitleID.Value = TitleID
      objCmd.Parameters.Add(paramTitleID)
    
      objConn.Open()   'Open the connection
    
      'Finally, return the SqlDataReader
      Return objCmd.ExecuteReader(CommandBehavior.CloseConnection)
    End Function
    
    
    Sub dgTitles_ItemCommand(sender As Object, e As DataGridCommandEventArgs)    
      If e.CommandName = "Details" then
        ' The details button has been clicked, find out the PK field value
        Dim strTitleID as String = e.CommandArgument
    
        ' Display the book's details
        dgBookDetails.DataSource = GetBookDetails(strTitleID)
        dgBookDetails.DataBind()
    
        ' Make sure the dgBookDetails DataGrid is Visible
        dgBookDetails.Visible = True
      End If
    End Sub

</script>
<form runat="server">  
  <%-- The dgBookDetails DataGrid displays the details
              for the selected book... --%>
  <asp:DataGrid runat="server" id="dgBookDetails" 
         Font-Name="Verdana" HorizontalAlign="Center"
         Visible="False" Width="85%">
    <HeaderStyle BackColor="Navy" ForeColor="White"
           Font-Size="11pt" HorizontalAlign="Center" />
           
    <ItemStyle BackColor="#eeeeee" Font-Size="9pt" />
  </asp:DataGrid>
  <p>&nbsp;</p>

  <%-- The dgTitles DataGrid displays all of the books --%>
  <asp:DataGrid runat="server" id="dgTitles"
        OnItemCommand="dgTitles_ItemCommand"
        AutoGenerateColumns="False" ShowHeader="False">
    <Columns>
      <asp:TemplateColumn>
        <ItemTemplate>
          <b>Title:</b> 
          <%# DataBinder.Eval(Container.DataItem, "title") %>
          <br />
          [<asp:LinkButton runat="server" id="btnDetails" 
             Text="View Book Details" CommandName="Details"
             CommandArgument='<%# DataBinder.Eval(Container.DataItem, "title_id") %>' />]
        </ItemTemplate>
      </asp:TemplateColumn>
    </Columns>
  </asp:DataGrid>
</form>
