<%@ Page Language="C#" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="C#">

    void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
        BindData();
    }
    
    
    void BindData()
    {
      // 1. Create a connection
      const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
      SqlConnection objConn = new SqlConnection(strConnString);
    
      // 2. Create a command object for the query
      const string strSQL = "SELECT * FROM titles";
      SqlCommand objCmd = new SqlCommand(strSQL, objConn);
    
      objConn.Open();   // Open the connection
    
      //F inally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection);
      dgTitles.DataBind();
    
      objConn.Close();   // Close the connection
    }
    
    
    SqlDataReader GetBookDetails(string TitleID)
    {
      // 1. Create a connection
      const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
      SqlConnection objConn = new SqlConnection(strConnString);
    
      // 2. Create a command object for the query
      String strSQL;
      strSQL = "SELECT title, type, pubdate, notes FROM titles " +
               "WHERE title_id = @TitleID";
      SqlCommand objCmd = new SqlCommand(strSQL, objConn);
    
      // 3. Create a parameter for the TitleID param
      SqlParameter paramTitleID = new SqlParameter("@TitleID", SqlDbType.VarChar, 10);
      paramTitleID.Value = TitleID;
      objCmd.Parameters.Add(paramTitleID);
    
      objConn.Open();   // Open the connection
    
      // Finally, return the SqlDataReader
      return objCmd.ExecuteReader(CommandBehavior.CloseConnection);
    }
    
    
    void ShowDetails(object sender, EventArgs e)
    {
       // Get the TitleID
       string strTitleID = dgTitles.DataKeys[dgTitles.SelectedIndex].ToString();
    
       // Display the book's details
       dgBookDetails.DataSource = GetBookDetails(strTitleID);
       dgBookDetails.DataBind();
    
       // Make sure the dgBookDetails DataGrid is Visible
       dgBookDetails.Visible = true;
    }

</script>
<form runat="server">
  <%-- The dgBookDetails DataGrid displays the details
              for the selected book... --%>
  <asp:DataGrid runat="server" id="dgBookDetails" 
         Font-Name="Verdana" HorizontalAlign="Center"
         Visible="False" Width="85%">
    <HeaderStyle BackColor="Navy" ForeColor="White"
           Font-Size="11pt" HorizontalAlign="Center" />
           
    <ItemStyle BackColor="#eeeeee" Font-Size="9pt" />
  </asp:DataGrid>
  <p>&nbsp;</p>

  <%-- The dgTitles DataGrid displays all of the books --%>
  <asp:DataGrid AutoGenerateColumns="False"
      runat="server" id="dgTitles"
      OnSelectedIndexChanged="ShowDetails"
      DataKeyField="title_id"
      Font-Name="Verdana" Font-Size="9pt">
      
     <SelectedItemStyle BackColor="#dddddd" Font-Italic="True"
          Font-Size="15pt" />
     
     <HeaderStyle BackColor="Navy" ForeColor="White"
          Font-Bold="True" HorizontalAlign="Center"
          Font-Size="11pt" />
     
     <Columns>
       <asp:ButtonColumn Text="Details" CommandName="Select"
              HeaderText="View Details" ItemStyle-HorizontalAlign="Center" />
       <asp:BoundColumn DataField="Title" HeaderText="Title" />
     </Columns> 
  </asp:DataGrid>
</form>
