<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData(String.Empty)
      End If
    End Sub
    
    
    Sub BindData(filterValue as String)
      DisplayViewingTypeMessage(filterValue)
      
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      
      'Create an appropriate SQL command string
      Dim strSQL as String
      If filterValue = String.Empty then
        strSQL = "SELECT * FROM titles"
      Else
        'SQL needs WHERE clause
        strSQL = "SELECT * FROM titles WHERE type = @TYPE"
      End If
      
      '2. Create a command object for the query
      Dim objCmd as New SqlCommand(strSQL, objConn)

      'Add parameter for WHERE clause if needed
      If strSQL <> String.Empty then
        Dim filterParam as New SqlParameter("@TYPE", SqlDbType.Char, 12)
        filterParam.Value = filterValue
        objCmd.Parameters.Add(filterParam)
      End If
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgTitles.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Sub FilterData(sender as Object, e as CommandEventArgs)
      BindData(e.CommandArgument)
    End Sub
    
    
    Sub DisplayViewingTypeMessage(filterValue as String)
      If filterValue = String.Empty then
        lblViewingMsg.Text = "You are viewing all books..."
      Else
        lblViewingMsg.Text = "You are viewing books of type " & filterValue
      End If
    End Sub

</script>

<form runat="server">
  <asp:Button Text="View ALL Books" runat="server"
            CommandArgument="" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type business" runat="server"
            CommandArgument="business" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type mod_cook" runat="server"
            CommandArgument="mod_cook" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type popular_comp" runat="server"
            CommandArgument="popular_comp" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type psychology" runat="server"
            CommandArgument="psychology" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type trad_cook" runat="server"
            CommandArgument="trad_cook" OnCommand="FilterData" />
  <asp:Button Text="View Books of Type UNDECIDED" runat="server"
            CommandArgument="UNDECIDED" OnCommand="FilterData" />
  <p>
    <asp:label id="lblViewingMsg" runat="server" Font-Name="Verdana"
           Font-Italic="True" Font-Color="Red" />
  </p> 
  <asp:DataGrid runat="server" id="dgTitles"
      AutoGenerateColumns="False"  CellPadding="5"
      Font-Name="Verdana"  Font-Size="9pt"
      AlternatingItemStyle-BackColor="#dddddd">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
              
    <Columns>
      <asp:BoundColumn DataField="title_id" HeaderText="Title ID"
             ItemStyle-HorizontalAlign="Center" />
      <asp:BoundColumn DataField="title" HeaderText="Title" />
      <asp:BoundColumn DataField="type" HeaderText="Type" />
    </Columns>
  </asp:DataGrid>
</form>
