<%@ Page Language="vb" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Sub Page_Load(sender as Object, e as EventArgs)
      AddFilterButtons()
    
      If Not Page.IsPostBack then
         'Populate the DataGrid
         BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
    
      'Create an appropriate SQL command string
      Const strSQL as String = "SELECT * FROM titles"
    
      '2. Create a command object for the query
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      '3. Create a DataAdapter and Fill the DataSet
      Dim objDA as New SqlDataAdapter()
      objDA.SelectCommand = objCmd
    
      Dim objDS as New DataSet()
      objDA.Fill(objDS, "titles")
    
      'Add the DataSet to the ViewState
      ViewState.Add("TitlesDataSet", objDS)
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = ViewState("TitlesDataSet")
      dgTitles.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Sub FilterData(sender as Object, e as CommandEventArgs)
      'Inform the user what filtering is being performed
      DisplayViewingTypeMessage(e.CommandArgument)
    
      'Get the DataSet out of the ViewState
      Dim objDS as DataSet = ViewState("TitlesDataSet")
    
      'Apply the filtering
      If e.CommandArgument = String.Empty then
        objDS.Tables("titles").DefaultView.RowFilter = ""
      Else  
        objDS.Tables("titles").DefaultView.RowFilter = "Type = '" & e.CommandArgument & "'"
      End If

      'Now, bind the DataGrid to the filtered DataSet
      dgTitles.DataSource = objDS.Tables("titles").DefaultView
      dgTitles.DataBind()
    End Sub
    
    
    Sub DisplayViewingTypeMessage(filterValue as String)
      If filterValue = String.Empty then
        lblViewingMsg.Text = "You are viewing all books..."
      Else
        lblViewingMsg.Text = "You are viewing books of type " & filterValue
      End If
    End Sub
    
    
    Sub AddFilterButtons()
      'Dynamically add the control buttons
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
    
      'Create an appropriate SQL command string
       Const strSQL as String = "SELECT DISTINCT type FROM titles ORDER BY type"
    
       '2. Create a command object for the query
       Dim objCmd as New SqlCommand(strSQL, objConn)
    
       objConn.Open()   'Open the connection
       Dim dr as SqlDataReader = objCmd.ExecuteReader()
    
       'Add the View ALL button
       Dim filterButton as New Button()
       filterButton.Text = "View ALL Books"
       filterButton.CommandArgument = ""
       filterButtonLocation.Controls.Add(filterButton)
       AddHandler filterButton.Command, AddressOf Me.FilterData
    
       'Now, loop through the SqlDataReader, adding buttons
       While dr.Read()
         filterButton = New Button()
         filterButtonLocation.Controls.Add(filterButton)

         filterButton.Text = "View Books of Type " & dr("type")
         filterButton.CommandArgument = dr("type")
         AddHandler filterButton.Command, AddressOf Me.FilterData
    
       End While
    
       objConn.Close()   'Close the connection
    End Sub

</script>
<form runat="server">
  <asp:PlaceHolder runat="server" id="filterButtonLocation" />
  <p>
    <asp:label id="lblViewingMsg" runat="server" Font-Name="Verdana"
           Font-Italic="True" Font-Color="Red" />
  </p> 
  <asp:DataGrid runat="server" id="dgTitles"
      AutoGenerateColumns="False"  CellPadding="5"
      Font-Name="Verdana"  Font-Size="9pt"
      AlternatingItemStyle-BackColor="#dddddd">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
              
    <Columns>
      <asp:BoundColumn DataField="title_id" HeaderText="Title ID"
             ItemStyle-HorizontalAlign="Center" />
      <asp:BoundColumn DataField="title" HeaderText="Title" />
      <asp:BoundColumn DataField="type" HeaderText="Type" />
    </Columns>
  </asp:DataGrid>
</form>
