<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="C#">

    void Page_Load(Object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
         //Populate the DataGrid
         BindData();
    }
    
    
    void BindData()
    {
      // 1. Create a connection
       const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
       SqlConnection objConn = new SqlConnection(strConnString);
    
      
      // Create an appropriate SQL command string
      const string strSQL = "SELECT title_id, title, price FROM titles";
      
      // 2. Create a command object for the query
      SqlCommand objCmd = new SqlCommand(strSQL, objConn);
      objConn.Open();
      
      // Finally, specify the DataSource and call DataBind()
      dlTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection);
      dlTitles.DataBind();
    
      objConn.Close();
    }
    
    
    void updatePrices(object sender, EventArgs e)
    {
      // 1. Create a connection
       const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
       SqlConnection objConn = new SqlConnection(strConnString);

      // Create an appropriate UPDATE statement
      const string strSQL = "UPDATE titles SET price = @price WHERE title_id = @titleID";
      
      // Create a command object for the query
      SqlCommand objCmd = new SqlCommand(strSQL, objConn);
      objConn.Open();
     
      string titleID, strPrice;
    
      // iterate through the DataList's TextBoxes
      foreach (DataListItem dlItem in dlTitles.Items)
      {
        // reference the TextBox
        TextBox txtPrices = (TextBox) dlItem.FindControl("txtPrice");
        
        // Grab the value
        strPrice = txtPrices.Text;
        
        // Get the title_id from DataKeys
        titleID = dlTitles.DataKeys[dlItem.ItemIndex].ToString();
        
        // Now, update the parameters
        SqlParameter priceParam = new SqlParameter("@price", SqlDbType.Money);
        if (strPrice == String.Empty)
          // we need to insert a NULL
          priceParam.Value = DBNull.Value;
        else
          priceParam.Value = strPrice;
        objCmd.Parameters.Add(priceParam);
          
        SqlParameter titleIDParam = new SqlParameter("@titleID", SqlDbType.VarChar, 6);
        titleIDParam.Value = titleID;
        objCmd.Parameters.Add(titleIDParam);
        
        // now, execute the query
        objCmd.ExecuteNonQuery();
        
        // Clear the parameters
        objCmd.Parameters.Clear();
      }
      
      objConn.Close();   // close the connection
    }

</script>

<form runat="server">
  <asp:Button Text="Update ALL Prices" runat="server"
        OnClick="updatePrices" />
  <p>
  <asp:DataList runat="server" id="dlTitles"
      CellPadding="5" BorderStyle="Inset"
      Font-Name="Verdana"  Font-Size="9pt"
      AlternatingItemStyle-BackColor="#dddddd"
      DataKeyField="title_id">

    <ItemTemplate>
      <b>Title:</b> <%# DataBinder.Eval(Container.DataItem, "title") %>
      <br /><b>Price:</b>
      <asp:TextBox runat="Server" id="txtPrice" Columns="5"
         Text='<%# DataBinder.Eval(Container.DataItem, "price") %>' />      
    </ItemTemplate>
  </asp:DataList>
</form>    
