<%@ Page Language="vb" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        dgComments.VirtualItemCount = GetTotalItemsInQuery()
        dgComments.CurrentPageIndex = 0
    
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      'Create a connection to the DB
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      Const strSQL as String = "sp_PageThroughData"
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
      objCmd.CommandType = CommandType.StoredProcedure
    
      Dim pageSizeParam as New SqlParameter("@PageSize", SqlDbType.Int, 4)
      pageSizeParam.Value = dgComments.PageSize
      objCmd.Parameters.Add(pageSizeParam)
    
      Dim currentPageParam as New SqlParameter("@CurrentPage", SqlDbType.Int, 4)
      currentPageParam.Value = dgComments.CurrentPageIndex
      objCmd.Parameters.Add(currentPageParam)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgComments.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgComments.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Sub dgComments_Paging(sender As Object, e As DataGridPageChangedEventArgs)
      dgComments.CurrentPageIndex = e.NewPageIndex
      BindData()
    End Sub
    
    
    Function GetTotalItemsInQuery()
      '1. Create a connection
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String
      strSQL = "SELECT COUNT(*) FROM Comments"
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      ' Get the number of records
      Dim recCount as Integer
      recCount = objCmd.ExecuteScalar()
    
      objConn.Close()
    
      Return recCount
    End Function

</script>
<form runat="server">
  <asp:DataGrid runat="server" id="dgComments"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="True" Width="75%"
      PageSize="10" AllowPaging="True"
      OnPageIndexChanged="dgComments_Paging"
      AllowCustomPaging="True">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
             
    <PagerStyle BackColor="Navy" ForeColor="White" Font-Size="8pt"
             Font-Bold="True" HorizontalAlign="Right"
             Mode="NumericPages" />
  </asp:DataGrid>
</form>